#include "CParts.h"

#define Begin Creator->MySetPort(); RGBBackColor(&Creator->GetBackColor());
#define End ::BackColor(whiteColor); Creator->RestoreWorld();

CPart::CPart(CWindowBase *TheCreator)
 {
 	Creator = TheCreator;
 	Creator->AddPart(this);
 	isFocused = false;
 }

CPart::~CPart()
{
 	Creator->GetCreator()->RemovePart(this);
}

CRectPart::CRectPart(Rect theRect, CWindowBase* theCreator, short Type):CPart(theCreator)
{
	ActionType = Type;
	mPartRect = theRect;
	Actif = true;
	CRectPart::InvalPart();
}

CRectPart::~CRectPart()
{
	if (Creator->GetWindow())
		InvalPart();
}

short CRectPart::InPart(Point thePoint)
{
	Rect theRect = mPartRect;
	Creator->MySetPort();
	short res = ((Actif) && PtInRect(thePoint, &mPartRect));
	Creator->RestoreWorld();
	return res;
}

void CRectPart::InvalPart()
{
	Creator->MySetPort();
	InvalRect(&mPartRect);
	Creator->RestoreWorld();
}

void CRectPart::SetPartRect(Rect newRect)
{
	InvalPart();
	mPartRect = newRect;
	InvalPart();
}

short CRectPart::DoClick(EventRecord*)
{
	if (Actif) {
		Creator->DoAction(ActionType, 0);
		return true;
		}
	return false;
}

short CRectPart::DoKey(EventRecord*)
{
	if (Actif) {
		Creator->DoAction(ActionType, 0);
		return true;
		}
	return false;
}

#pragma mark -

CIconPart::CIconPart(Handle theIcon, Rect theRect, CWindowBase* theCreator, short Type): \
	CRectPart(theRect, theCreator, Type)
{
	Icone = theIcon;
}

CIconPart::~CIconPart()
{
}

void CIconPart::DrawPart()
{
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	PlotIcon(&mPartRect, Icone);
	::BackColor(whiteColor);
}

void CIconPart::SetIcon(Handle theIcon)
{
	Icone = theIcon;
	InvalPart();
}

void CIconPart::_Enable()
{
}

void CIconPart::_Disable()
{
}

#pragma mark -

cicnButton::cicnButton(short ID, Rect theRect, CWindowBase* theCreator, short Type, CResFileBase* theFile): \
	CRectPart(theRect, theCreator, Type)
{
	icnFile = theFile;
	Item = ID;
	if (theFile) {
		theFile->UseThisFile();
		Icone1 = GetCIcon(ID);
		Icone2 = GetCIcon(ID+1);
		theFile->UseHomeFile();
		}
	else {
		Icone1 = GetCIcon(ID);
		Icone2 = GetCIcon(ID+1);
		}
	
	relache = true;
	down = false;
	passive = false;
}

cicnButton::~cicnButton()
{
	DisposeCIcon(Icone1);
	DisposeCIcon(Icone2);
}

short cicnButton::DoClick(EventRecord* event)
{
	if (passive) return false;
	if (Enfonce(relache))
		DoAction();
	return true;
}

void cicnButton::DrawPart()
{
	if (down)
		PlotCIcon(&mPartRect, Icone2);
	else
		PlotCIcon(&mPartRect, Icone1);
}

void cicnButton::SetIcon(short theIcon)
{
	Item = theIcon;
	DisposeCIcon(Icone1);
	DisposeCIcon(Icone2);
	if (icnFile) {
		icnFile->UseThisFile();
		Icone1 = GetCIcon(theIcon);
		Icone2 = GetCIcon(theIcon+1);
		icnFile->UseHomeFile();
		}
	else {
		Icone1 = GetCIcon(theIcon);
		Icone2 = GetCIcon(theIcon+1);
		}
	InvalPart();
}

void cicnButton::_Enable()
{
	Creator->MySetPort();
	DisposeCIcon(Icone1);
	if (icnFile) {
		icnFile->UseThisFile();
		Icone1 = GetCIcon(Item);
		icnFile->UseHomeFile();
		}
	else {
		Icone1 = GetCIcon(Item);
		}
	DrawPart();
	Creator->RestoreWorld();
}

void cicnButton::_Disable()
{
	Creator->MySetPort();
	DisposeCIcon(Icone1);
	if (icnFile) {
		icnFile->UseThisFile();
		Icone1 = GetCIcon(Item+((down)?3:2));
		icnFile->UseHomeFile();
		}
	else {
		Icone1 = GetCIcon(Item+((down)?3:2));
		}
	DrawPart();
	Creator->RestoreWorld();
}

void cicnButton::SetDown(short N)
{
	down = N;
	Creator->MySetPort();
	DrawPart();
	Creator->RestoreWorld();
}

Boolean cicnButton::Enfonce(Boolean Relachement)
{
	Creator->MySetPort();
	EventRecord Relache;
	Boolean Appuie = false;
	Point MonEndroit;
	do {
		GetMouse(&MonEndroit);
		if (PtInRect(MonEndroit, &mPartRect) && !(Appuie))
			{
			PlotCIcon(&mPartRect, Icone2);
			Appuie = true;
			}
		if (!(PtInRect(MonEndroit, &mPartRect)) && Appuie)
			{
			if (!down)
				PlotCIcon(&mPartRect, Icone1);
			Appuie = false;
			}
		} while (!(GetNextEvent(mUpMask, &Relache)));
	if (Relachement) PlotCIcon(&mPartRect, Icone1);
	else if (Appuie) {
		down = (!down);
		if (down)
			PlotCIcon(&mPartRect, Icone2);
		else
			PlotCIcon(&mPartRect, Icone1);
		}
	Creator->RestoreWorld();
	return Appuie;
}

void cicnButton::DoAction()
{
	Creator->DoAction(ActionType, 0);
}

