#include "CConstants.h"
#include "CCursor.h"
#include "CParts3.h"
#include "Compat.h"

CMenuButton::CMenuButton(short MenuID, short UnChoix, Rect theRect, CWindowBase *TheCreator, CResFileBase* theFile): CTextPart("", theRect, TheCreator)
{
	myID = MenuID;
	myFile = theFile;
	theMenu = Creator->GetCreator()->GetMenu(MenuID, theFile)->GetMenu();
	for (short i = 0; i<= CountMItems(theMenu); i++)
		EnableItem(theMenu, i);
	
	MenuControl = NewControl(TheCreator->GetWindow(), &theRect, "\p", false, 0, (**theMenu).menuID, 0, popupMenuProc, 0);
	ControlFontStyleRec theStyle;
	theStyle.font = kFontIDGeneva;
	theStyle.size = 9;
	theStyle.flags = kControlUseFontMask + kControlUseSizeMask;
	SetControlFontStyle(MenuControl, &theStyle);
	PutChoice(UnChoix);
	
	ShowControl(MenuControl);
}

CMenuButton::~CMenuButton()
{
	DisposeControl(MenuControl);
}

void CMenuButton::ChangedMenu(short newVal)
{
	Creator->MySetPort();
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	Rect myRect = {0,0,0,0};
	ClipRect(&myRect);
	DisposeControl(MenuControl);
	ClipRect(&Creator->GetWindow()->portRect);
	
	MenuControl = NewControl(Creator->GetWindow(), &mPartRect, "\p", false, 0, (**Creator->GetCreator()->GetMenu(myID, myFile)->GetMenu()).menuID, 0, popupMenuProc, 0);
	ControlFontStyleRec theStyle;
	theStyle.font = kFontIDGeneva;
	theStyle.size = 9;
	theStyle.flags = kControlUseFontMask + kControlUseSizeMask;
	SetControlFontStyle(MenuControl, &theStyle);
	::SetControlValue(MenuControl, newVal);
	ShowControl(MenuControl);

	Choix = newVal;
	BackColor(whiteColor);
	Creator->RestoreWorld();
}

void CMenuButton::_Enable()
{
	HiliteControl(MenuControl,0);
}

void CMenuButton::_Disable()
{
	HiliteControl(MenuControl,255);
}

void CMenuButton::DrawPart()
{
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	Draw1Control(MenuControl);
	BackColor(whiteColor);
}

short CMenuButton::DoClick(EventRecord* theEvent)
{
	if (Actif) {
		RGBColor bc = Creator->GetBackColor();
		RGBBackColor(&bc);
		short Res = TrackControl(MenuControl, theEvent->where, (RoutineDescriptor*)(-1));
		Draw1Control(MenuControl);
		BackColor(whiteColor);
		Choix = GetControlValue(MenuControl);
		Creator->DoAction(kMenuCommand, (myID << 16) + Choix);
		return true;
		}
	return false;
}

void CMenuButton::PutChoice(short MonChoix)
{
	Creator->MySetPort();
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	Choix = MonChoix;
	::SetControlValue(MenuControl, Choix);
	Draw1Control(MenuControl);
	BackColor(whiteColor);
	Creator->RestoreWorld();
}

void CMenuButton::_UpDateText(short)
{
	ControlFontStyleRec theStyle;
	theStyle.font = Font;
	theStyle.size = Size;
	theStyle.style = Face;
	theStyle.just = Justify;
	theStyle.flags = kControlUseFontMask + kControlUseSizeMask + kControlUseFaceMask + kControlUseJustMask;
	SetControlFontStyle(MenuControl, &theStyle);
}

#pragma mark -

COffScreenPart::COffScreenPart(Rect theRect, CWindowBase *TheCreator, short depth, short drawFrame):  \
	CRectPart(theRect, TheCreator), COffScreenWorld(depth, theRect, TheCreator->GetCreator())
{
	isActif = true;
}

COffScreenPart::~COffScreenPart()
{
}

void COffScreenPart::DrawPart()
{
	ForeColor(blackColor);
	BackColor(whiteColor);
	Rect theRect = mPartRect;
	OffsetRect(&theRect, -theRect.left, -theRect.top);
	CopyTo(Creator, theRect, mPartRect);
	theRect = mPartRect;
	InsetRect(&theRect, -1, -1);
	if (isActif)
		FrameRect(&theRect);
	else {
		RGBForeColor(&FondGris);
		FrameRect(&theRect);
		ForeColor(blackColor);
		}
}

void COffScreenPart::_Enable()
{
	isActif = true;
	Rect theRect = mPartRect;
	InsetRect(&theRect, -1, -1);
	Creator->MySetPort();
	FrameRect(&theRect);
	Creator->RestoreWorld();
}

void COffScreenPart::_Disable()
{
	isActif = false;
	Rect theRect = mPartRect;
	InsetRect(&theRect, -1, -1);
	Creator->MySetPort();
	RGBForeColor(&FondGris);
	FrameRect(&theRect);
	ForeColor(blackColor);
	Creator->RestoreWorld();
}

#pragma mark -

CPointsPart::CPointsPart(Rect theRect, CWindowBase* theCreator):COffScreenPart(theRect, theCreator, 1, true)
{
	myPoints = new CList< complex<double> >;
	complex<double>* myPt = new complex<double>(0,0);
	myPoints->Add(myPt);
	myPt = new complex<double>(1,0);
	myPoints->Add(myPt);
	
	OffRect = theRect;
	OffsetRect(&OffRect, -OffRect.left, -OffRect.top);
	CPointsPart::UpDatePart();
}

CPointsPart::~CPointsPart()
{
	myPoints->Destroy();
	delete myPoints;
}

void CPointsPart::EnterPart()
{
	CCursor::SetCursor(kCrossCursor);
}

void CPointsPart::LeavePart()
{
}

short CPointsPart::DoClick(EventRecord* myEvent)
{
	Creator->MySetPort();
	Point theMouse = myEvent->where;
	theMouse.h -= mPartRect.left;
	theMouse.v -= mPartRect.top;
	complex<double> *myPoint = AddPoint(theMouse);
	if (!myPoint) {
		Creator->RestoreWorld();
		return false;
		}
	if (myShow) myShow->Show(myPoint->real(), myPoint->imag());

	Point oldMouse = theMouse;
	short removed = false;
	
	UpDatePart();
	DrawPart();
	while (Button()) {
		GetMouse(&theMouse);
		theMouse.h -= mPartRect.left;
		theMouse.v -= mPartRect.top;
		if (!(EqualPt(theMouse, oldMouse))) {
			oldMouse = theMouse;
			MovePoint(myPoint, theMouse, removed);
			UpDatePart();
			DrawPart();
			}
		}
	Creator->RestoreWorld();
	if (myShow) myShow->Show(-1,-1);
	return true;
}

complex<double> *CPointsPart::AddPoint(Point Pos)
{
	double thePos = (double)Pos.h / OffRect.right;
	double vPos = 1-(2*(double)Pos.v / OffRect.bottom);
	complex<double>* myPt = myPoints->GetFirst();
	complex<double>* oldPt = myPoints->GetFirst();
	while (myPt) {
		if (abs(real(*myPt)*OffRect.right - Pos.h) <= 2) {
			*myPt = complex<double>(myPt->real(), vPos);
			return myPt;
			}
		if ((oldPt->real() < thePos) && (real(*myPt) > thePos)) {
			complex<double>* aPoint = new complex<double>(thePos, vPos);
			myPoints->GetIndex(oldPt);
			myPoints->InsertAfterCurrent(aPoint);
			return aPoint;
			}
		oldPt = myPt;
		myPt = myPoints->GetNext();
		}
	return 0;
}

void CPointsPart::MovePoint(complex<double>* thePoint, Point Pos, short& removed)
{
	if (removed) return;
	double hPos = (double)Pos.h / OffRect.right;
	double vPos = 1-(2*(double)Pos.v / OffRect.bottom);
	
	long theIndex = myPoints->GetIndex(thePoint);
	if ((theIndex == 0) || (theIndex == (myPoints->GetSize() - 1))) {
		if (vPos > 1) vPos = 1;
		if (vPos < -1) vPos = -1;
		*thePoint = complex<double>(thePoint->real(), vPos);
		if (myShow) myShow->Show(thePoint->real(), thePoint->imag());
		return;
		}
	
	short outofrange = false;
	outofrange |= (hPos <= (*myPoints)[theIndex-1]->real());
	outofrange |= (hPos >= (*myPoints)[theIndex+1]->real());
	outofrange |= (abs(vPos) > 1);
	if (outofrange) {
		removed = true;
		myPoints->Remove(thePoint);
		if (myShow) myShow->Show(-1,-1);
		return;
		}

	*thePoint = complex<double>(hPos, vPos);
	if (myShow) myShow->Show(thePoint->real(), thePoint->imag());
}

void CPointsPart::_MoveTo(complex<double>* pos)
{
	MoveTo(real(*pos) * OffRect.right, OffRect.bottom*(1 - imag(*pos))/2);
}

void CPointsPart::_LineTo(complex<double>* pos)
{
	if (linear)
		LineTo(real(*pos) * OffRect.right, OffRect.bottom*(1 - imag(*pos))/2);
	else {
		Point dep = theWorld->pnLoc;
		Point arr;
		SetPt(&arr, real(*pos) * OffRect.right,OffRect.bottom*(1 - imag(*pos))/2);
		for (short i=1; i<= arr.h - dep.h; i++)
			LineTo(dep.h + i, (dep.v + arr.v)/2.0f + cos(i*pi/(arr.h-dep.h))*(dep.v - arr.v)/2.0f);
		}
}

void CPointsPart::SetPoints(CList< complex<double> > *newPoints)
{
	myPoints->Destroy();
	delete myPoints;
	myPoints = newPoints;
	UpDatePart();
	Creator->MySetPort();
	DrawPart();
	Creator->RestoreWorld();
}

void CPointsPart::UpDatePart()
{
	MySetPort();
	Rect myRect = {0,0,1000, 1000};
	EraseRect(&myRect);
	complex<double> *myPt = myPoints->GetFirst();
	_MoveTo(myPt);
	Move(1,1);
	Line(0, -2);
	Line(-2, 0);
	Line(0, 2);
	Line(2, 0);
	Move(-1,-1);
	myPt = myPoints->GetNext();
	while (myPt) {
		_LineTo(myPt);

	Move(1,1);
	Line(0, -2);
	Line(-2, 0);
	Line(0, 2);
	Line(2, 0);
	Move(-1,-1);

		myPt = myPoints->GetNext();
		}
	RestoreWorld();
}

double CPointsPart::GetFunction(double x)
{
	if (x<0) return myPoints->GetFirst()->imag();
	if (x>1) return myPoints->GetLast()->imag();
	complex<double> *pt1 = myPoints->GetFirst();
	complex<double> *pt2 = myPoints->GetNext();
	while (pt2) {
		if ((x >= pt1->real()) && (x <= pt2->real()))
			return pt1->imag() + (x - pt1->real())*(pt2->imag() - pt1->imag()) / (pt2->real() - pt1->real());
		pt1 = pt2;
		pt2 = myPoints->GetNext();
		}
	return 0;
}

void CPointsPart::SetLinear(short nlin)
{
	linear = nlin;
	UpDatePart();
	Creator->MySetPort();
	DrawPart();
	Creator->RestoreWorld();
}

void CPointsPart::SetToZero()
{
	myPoints->Destroy();
	complex<double>* myPt = new complex<double>(0,0);
	myPoints->Add(myPt);
	myPt = new complex<double>(1,0);
	myPoints->Add(myPt);
	
	UpDatePart();
	Creator->MySetPort();
	DrawPart();
	Creator->RestoreWorld();
}

void CPointsPart::InvalPart()
{
	Rect invRect = mPartRect;
	InsetRect(&invRect, -1, -1);
	Creator->MySetPort();
	InvalRect(&invRect);
	Creator->RestoreWorld();
}

#pragma mark -

CScalePart::CScalePart(Rect myRect, CWindowBase* Cre, short Msg):CRectPart(myRect, Cre, Msg)
{
	if ((mPartRect.right - mPartRect.left) > (mPartRect.bottom - mPartRect.top))
		horiz = true;
	else
		horiz = false;
	isActif = true;
	logarithmic = false;
	min = 0;
	max = 1;
	bigSpace = 0.5;
	nSmall = 5;
	orientation = true;
	theLength = (horiz)?(mPartRect.right - mPartRect.left):(mPartRect.bottom - mPartRect.top);
	theLength--;
	
	before = (string)"";
	after = (string)"";
	
	format = (string)"%s%1.0lf%s";
}

void CScalePart::SetPartRect(Rect nRect)
{
	CRectPart::SetPartRect(nRect);
	if ((mPartRect.right - mPartRect.left) > (mPartRect.bottom - mPartRect.top))
		horiz = true;
	else
		horiz = false;
	theLength = (horiz)?(mPartRect.right - mPartRect.left):(mPartRect.bottom - mPartRect.top);
	theLength--;	
}

void CScalePart::SetDigits(short n)
{
	format[5] = '0' + n;
	InvalPart();
}

string CScalePart::MakeText(double x)
{
	char s[50];
	sprintf(s, format.c_str(), before.c_str(), x, after.c_str());
	return s;
}

void CScalePart::DrawPart()
{
	BackColor(whiteColor);
	TextSize(9);
	TextFont(kFontIDGeneva);
	TextFace(0);
	double first, pos;
	short i;
	if (isActif)
		RGBForeColor(&FondGris2);
	else
		RGBForeColor(&FondGris);
	if (!logarithmic) {
		first = (long)(min/bigSpace) * bigSpace;
		if (first > min) first -= bigSpace;
		for (pos = first; pos <= max; pos += bigSpace) {
			for (i=1; i<nSmall; i++) {
				DrawSmall(0.5+theLength * (pos + i*bigSpace/(double)nSmall - min)/(max-min));
				}
			}
		if (isActif)
			ForeColor(blackColor);
		else
			RGBForeColor(&FondGris2);
		
		for (pos = first; pos <= max; pos += bigSpace)
			DrawBig(0.5+theLength * (pos - min)/(max-min), pos);
		}
	else {
		first = exp((long)(log(min)/log(bigSpace)) * log(bigSpace));
		if (first > min) first /= bigSpace;
		for (pos = first; pos <= max; pos *= bigSpace)
			for (i=1; i<nSmall; i++) {
				DrawSmall(0.5+theLength * log((pos*(1+i*(bigSpace-1)/(double)nSmall))/min)/log(max/min));
				}
		if (isActif)
			ForeColor(blackColor);
		else
			RGBForeColor(&FondGris2);

		for (pos = first; pos <= max; pos *= bigSpace)
			DrawBig(0.5+theLength * log(pos/min)/log(max/min), pos);
		}
	ForeColor(blackColor);
}

void CScalePart::DrawSmall(short Pos)
{
	if ((Pos < 0) || (Pos > theLength)) return;
	short pH = (horiz)?(mPartRect.left + Pos):((orientation)?mPartRect.right-4:mPartRect.left);
	short pV = (horiz)?((orientation)?mPartRect.top:mPartRect.bottom-3):mPartRect.bottom - Pos - 1;
	MoveTo(pH,pV);
	if (horiz) Line(0,3); else Line(3,0);
}

void CScalePart::DrawBig(short Pos, double x)
{
	if ((Pos < 0) || (Pos > theLength)) return;
	short pH = (horiz)?(mPartRect.left + Pos):((orientation)?mPartRect.right-6:mPartRect.left);
	short pV = (horiz)?((orientation)?mPartRect.top:mPartRect.bottom-5):mPartRect.bottom - Pos - 1;
	MoveTo(pH,pV);
	if (horiz) Line(0,5); else Line(5,0);
	
	string myText = MakeText(x);
	Rect myRect;
	
	short dh;
	short dv;
	short just;
	
	Str255 pText;
	String2Pas(myText, pText);
	short width = StringWidth(pText);
	if (horiz) {
		dh = -3;
		dv = 8;
		just = teFlushLeft;
		}
	else {
		dh = -(8+width);
		dv = -7;
		just = teFlushRight;
		}
	SetRect(&myRect, pH + dh, pV + dv, pH + dh + 3+width, pV + dv + 11);
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	TETextBox((void*)myText.c_str(),myText.length(), &myRect, just);
	BackColor(whiteColor);
}

void CScalePart::_Enable()
{
	isActif = true;
	Creator->MySetPort();
	DrawPart();
	Creator->RestoreWorld();
}

void CScalePart::_Disable()
{
	isActif = false;
	Creator->MySetPort();
	DrawPart();
	Creator->RestoreWorld();
}

void CScalePart::InvalPart()
{
	Rect invRect = mPartRect;
	if (horiz) {
		invRect.right += 30;
		invRect.left -= 5;
		}
	else {
		invRect.top -= 5;
		invRect.bottom += 5;
		}
	Creator->MySetPort();
	InvalRect(&invRect);
	Creator->RestoreWorld();
}
