#include "CConstants.h"
#include "CCursor.h"
#include "CParts4.h"

CListPart::CListPart(Rect theRect, CWindowBase *TheCreator): CRectPart(theRect, TheCreator, 0)
{
	isActif = true;
	doubleAction = 0;
	_MakeList();
	Point theCell = {0,0};
	LSetSelect(true, theCell, theList);
}

CListPart::~CListPart()
{
	LDispose(theList);
}

void CListPart::DrawFocus()
{
	Rect FocRect = mPartRect;
	InsetRect(&FocRect, -3, -3);
	PenSize(2,2);
	RGBColor bc = Creator->GetBackColor();
	if ((isActif) && (isFocused))
		RGBForeColor(&FondGris2);
	else
		RGBForeColor(&bc);
	FrameRect(&FocRect);
	ForeColor(blackColor);
	PenSize(1,1);
}

void CListPart::GiveFocus(short FromTab)
{
	isFocused = true;
	DrawFocus();
}

void CListPart::TakeFocus()
{
	isFocused = false;
	DrawFocus();
}

void CListPart::_MakeList()
{
	Rect dataRect = {0,0,0,0};
	Point cSize = {0,0};
	Rect myRect = mPartRect;
	myRect.right -= 15;
	InsetRect(&myRect,1,1);
	Creator->MySetPort();
	TextSize(9);
	TextFont(kFontIDGeneva);
	TextFace(0);
	theList = LNew(&myRect, &dataRect, cSize, 0, Creator->GetWindow(), true, false, false, true);
	LActivate(true, theList);
	(**theList).selFlags = lOnlyOne;
	LAddColumn(1,0,theList);
	FrameRect(&mPartRect);
	Creator->RestoreWorld();
}

void CListPart::_Enable()
{
	isActif = true;
	LActivate(true, theList);
	DrawFocus();
}

void CListPart::_Disable()
{
	isActif = false;
	LActivate(false, theList);
	DrawFocus();
}

void CListPart::DrawPart()
{
	TextFace(0);
	TextFont(kFontIDGeneva);
	TextSize(9);
	BackColor(whiteColor);
	EraseRect(&mPartRect);
	RgnHandle myRgn = NewRgn();
	RectRgn(myRgn, &mPartRect);
	LUpdate(myRgn, theList);
	DisposeRgn(myRgn);	
	FrameRect(&mPartRect);
	DrawFocus();
}

short CListPart::DoClick(EventRecord* theEvent)
{
	short doubleClick = LClick(theEvent->where, theEvent->modifiers, theList);
	Point theCell = {0,0};
	short isSel = LGetSelect(true, &theCell, theList);
	if (!isSel)
		LSetSelect(true, theCell, theList);

	if ((doubleClick) && (doubleAction))
		Creator->DoAction(doubleAction, 0);
	return true;
}

short CListPart::GetSelection()
{
	Point theCell = {0,0};
	LGetSelect(true, &theCell, theList);
	return theCell.v;
}

void CListPart::AddItem(string s)
{
	short Row = LAddRow(1,1000,theList);
	Point Where;
	SetPt(&Where, 0, Row);
	LSetCell((void*)s.c_str(), s.length(), Where, theList);
}

short CListPart::DoKey(EventRecord* theEvent)
{
	Point theCell = {0,0};
	if (isFocused) {
		char Char  = theEvent->message & charCodeMask;
		switch (Char) {
			case 30:
				LGetSelect(true, &theCell, theList);
				LSetSelect(false, theCell, theList);
				if (theCell.v > 0)
					theCell.v--;
				else
					theCell.v = (**theList).dataBounds.bottom-1;
				LSetSelect(true, theCell, theList);
				LAutoScroll(theList);
				return true;
			case 31:
				LGetSelect(true, &theCell, theList);
				LSetSelect(false, theCell, theList);
				if (theCell.v < (**theList).dataBounds.bottom-1)
					theCell.v++;
				else
					theCell.v = 0;
				LSetSelect(true, theCell, theList);
				LAutoScroll(theList);
				return true;
			default:
				return false;
			}
		}
	else
		return false;
}

