#include "CBaseClasses.h"
#include "CUtils.h"
#include "CUtilClasses.h"

#include "Errors.h"
#include "FFT.h"
#include "fftlib.h"
#include "fftext.h"

void _FFT (long Adresse, long ld, short ISign) {
static long oldLd = 0;
static double* Utbl = 0;
static short* Brevs = 0;

	long N = (1 << ld);
	if (ld != oldLd) {
		oldLd = ld;
		if (Utbl) delete []Utbl;
		if (Brevs) delete []Brevs;
		Utbl = (double*)calloc((N/4+1),sizeof(double));
		Brevs = (short*)calloc((1 << (ld/2-1)),sizeof(short));
		fftCosInit(oldLd, Utbl);
		fftBRInit(oldLd, Brevs);
		}
	if (ISign > 0)
		ffts1((double*)Adresse, ld, 1, Utbl, Brevs);
	else {
		iffts1((double*)Adresse, ld, 1, Utbl, Brevs);
		for (long i=0; i<2*N; i++)
			*(((double*)Adresse)+i) *= N;
		}
	}

void _FFT_old (long Adresse, long ld, short ISign) {
#define ComplexPtr complex<double>*

	ComplexPtr AComplex;
	ComplexPtr BComplex;
	long n = (1 << ld), i, j=0, k;
	for (k = 1; k<= n - 2; k++) {
		long m = (n>>1);
		while (j >= m) {
			j -= m;
			m = (m>>1);
			}
		j += m;
		if (k > j) {
			AComplex = (ComplexPtr)(Adresse + j * ComplexSize);
			complex<double> zj = *AComplex;
			BComplex = (ComplexPtr)(Adresse + k * ComplexSize);
			*AComplex = *BComplex;
			*BComplex = zj;
			}
		}
		long nm1 = n - 1;
		long nft = 1, l;
		for (l = 1; l<= ld; l++) {
			long nfth = nft;
			nft *= 2;
			double alpha = pi / nfth;
			if (ISign < 0) alpha = -alpha;
			complex<double> w = complex<double>(cos(alpha), sin(alpha));
			complex<double> wk = 1;
			for (k = 0; k< nfth; k++) {
				i = k;
				do {
					j = i + nfth;
					AComplex = (ComplexPtr)(Adresse + j * ComplexSize);
					complex<double> wkzj = wk * (*AComplex);
					BComplex = (ComplexPtr)(Adresse + i * ComplexSize);
					complex<double> zi = *BComplex;
					*BComplex = zi + wkzj;
					*AComplex = zi - wkzj;
					i += nft;
					} while (i < nm1);
				wk *= w;
				}
			}
	}

/*void _RealFT (long Adresse, long ld, short ISign) {
static long oldLd = 0;
static double* Utbl = 0;
static short* Brevs = 0;
	ld++;
	long N = (1 << ld);
	if (ld != oldLd) {
		oldLd = ld;
		if (Utbl) delete []Utbl;
		if (Brevs) delete []Brevs;
		Utbl = (double*)calloc((N/4+1),sizeof(double));
		Brevs = (short*)calloc((1 << ((ld-1)/2-1)),sizeof(short));
		fftCosInit(oldLd, Utbl);
		fftBRInit(oldLd, Brevs);
		}
	if (ISign > 0)
		rffts1((double*)Adresse, ld, 1, Utbl, Brevs);
	else {
		riffts1((double*)Adresse, ld, 1, Utbl, Brevs);
		for (long i=0; i<2*N; i++)
			*(((double*)Adresse)+i) *= N;
		}
	}
*/
void _RealFT (long Adresse, long ld, short ISign) {
	long N = (1 << ld);
	ld++;
	fftInit(ld);
	if (ISign > 0)
		rffts((double*)Adresse, ld, 1);
	else {
		riffts((double*)Adresse, ld, 1);
		for (long i=0; i<2*N; i++)
			*(((double*)Adresse)+i) *= N;
		}
	}

void _RealFT_old (long Adresse, long ld, short ISign) {
	double *Data1, *Data2, *Data3, *Data4;
	long n = (1 << ld);
	double Theta = pi / n;
	double c1 = 0.5, c2;
	if (ISign == 1) {
		c2 = -0.5;
		_FFT(Adresse, ld, 1);
		}
	else {
		c2 = 0.5;
		Theta = -Theta;
		}
	double wpr = -2 * sin(Theta*0.5)*sin(Theta*0.5);
	double wpi = sin(Theta);
	double wr = 1 + wpr;
	double wi = wpi;
	long n2p3 = 2 * n + 3, i;
	
		Data1 = (double*)(Adresse + RealSize * 2);
		Data2 = (double*)(Adresse + RealSize * 3);
		Data3 = (double*)(Adresse + RealSize * (2*n-2));
		Data4 = (double*)(Adresse + RealSize * (2*n-1));
		
	for (i = 2; i<= n / 2; i++) {
		double wrs = wr;
		double wis = wi;
		double h1r = c1 * (*Data1 + *Data3);
		double h1i = c1 * (*Data2 - *Data4);
		double h2r = -c2 * (*Data2 + *Data4);
		double h2i = c2 * (*Data1 - *Data3);
		*Data1 = h1r + wrs * h2r - wis * h2i;
		*Data2 = h1i + wrs * h2i + wis * h2r;
		*Data3 = h1r - wrs * h2r + wis * h2i;
		*Data4 = -h1i + wrs * h2i + wis * h2r;
		double wtemp = wr;
		wr = wr * wpr - wi * wpi + wr;
		wi = wi * wpr + wtemp * wpi + wi;
	
		Data1 = (double*)((long)(Data1) + ComplexSize);
		Data2 = (double*)((long)(Data2) + ComplexSize);
		Data3 = (double*)((long)(Data3) - ComplexSize);
		Data4 = (double*)((long)(Data4) - ComplexSize);
/*		Data1 += 2;
		Data2 += 2;
		Data3 -= 2;
		Data4 -= 2;*/
		}
	if (ISign == 1) {
		Data1 = (double*)(Adresse);
		Data2 = (double*)(Adresse + RealSize);
		double h1r = *Data1;
		*Data1 = h1r + *Data2;
		*Data2 = h1r - *Data2;
		}
	else {
		Data1 = (double*)(Adresse);
		Data2 = (double*)(Adresse + RealSize);
		double h1r = *Data1;
		*Data1 = c1 * (h1r + *Data2);
		*Data2 = c1 * (h1r - *Data2);
		_FFT(Adresse, ld, -1);
		}
	}
	
#pragma mark -
	
CSpec::CSpec(short l)
{
	SizeLog = l;
	dataSize = (1 << l);
	mDatas = new CPtr(dataSize * ComplexSize);
}

CSpec::~CSpec()
{
	delete mDatas;
}

void CSpec::FFT()
{
//	long i=0;
	_RealFT(mDatas->GetAddress(), SizeLog, 1);

//	double* myNumber = (double*)(mDatas->GetAddress());
}

void CSpec::InvFFT()
{
	_RealFT(mDatas->GetAddress(), SizeLog, -1);
}

void CSpec::CopyFromSound(CSoundBase* Source,long Pos,short OffSet, short jump)
{
	CSoundAccess *myAccess = Source->GetReadAccess(Pos, 2*dataSize*jump);
	if (!myAccess) return;
	CSample *mySample = myAccess->GetSamplePtr(0, OffSet);
	short SSize = Source->SampleSize()*jump;
	
	double* myNumber = (double*)(mDatas->GetAddress());
	double datSize = dataSize;
	long i=0, AddrPos = (long)(mySample);

#define Action(Get)	for (i=0; i<2*dataSize; i++)				\
		{*(myNumber++) = mySample->Get() / datSize;		\
		mySample = (CSample*)(AddrPos += SSize);	}

	switch (Source->NBytes()) {
		case 1:
			Action(get8);
			break;
		case 2:
			Action(get16);
			break;
		case 3:
			Action(get24);
			break;
		}
#undef Action
	delete myAccess;
}

void CSpec::CopyFromPtr(long Address, SoundCar theCar, short jump)
{
	CSample *mySample = (CSample*)Address;
	
	short SSize = jump * theCar.SampleSize();
	double* myNumber = (double*)(mDatas->GetAddress());
	double datSize = dataSize;
	long i=0, AddrPos = Address;

#define Action(Get)	for (i=0; i<2*dataSize; i++)				\
		{*(myNumber++) = mySample->Get() / datSize;		\
		mySample = (CSample*)(AddrPos += SSize);	}

	switch (theCar.mSampleSize) {
		case 1:
			Action(get8);
			break;
		case 2:
			Action(get16);
			break;
		case 3:
			Action(get24);
			break;
		}
#undef Action
}

void CSpec::CopyToSound(CSoundBase* Dest,long Pos,short OffSet, long Add1, long Add2)
{
	CSoundAccess *myAccess = Dest->GetWriteAccess(Pos, 2*dataSize);
	if (!myAccess) return;
	CSample *mySample = myAccess->GetSamplePtr(0, OffSet);
	short SSize = Dest->SampleSize();
	
	double* myNumber = (double*)(mDatas->GetAddress());
	double datSize = dataSize;
	long i=0, AddrPos = (long)(mySample);

#define Action(Put, Get)	for (i=0; i<2*dataSize; i++)						\
		{ 	if ((i < Add1) || (i >= 2*dataSize - Add2)) 								\
				mySample->Put(*(myNumber++) + mySample->Get());		\
			else mySample->Put(*(myNumber++));									\
			mySample = (CSample*)(AddrPos += SSize);	}

/*#define Action(Put, Get)	for (i=0; i<2*dataSize; i++)					\
		{ 	mySample->Put(*(myNumber++));									\
			mySample = (CSample*)(AddrPos += SSize);	}*/


	switch (Dest->NBytes()) {
		case 1:
			Action(putTest8, get8);
			break;
		case 2:
			Action(putTest16, get16);
			break;
		case 3:
			Action(putTest24, get24);
			break;
		}

#undef Action

	delete myAccess;
}

void CSpec::MakeOverlap(short AtStart, long theOverlap, short OverlapMode, long Slide)
{
	if (theOverlap > dataSize) theOverlap = dataSize;
	
	double* myNumber;
	if (AtStart)
		myNumber = (double*)(mDatas->GetAddress() + Slide*RealSize);
	else
		myNumber = (double*)(mDatas->GetAddress() + (2*dataSize - theOverlap - Slide)*RealSize);
	double fact = 0, z;
	long i=0;

#define Linear(x) x
#define Smooth(x) ((1-cos(3.14159265358979 * x))/2)
#define Cut(x) ((x<0.33333333) || (x > 0.66666666))?(long)(1.7*x):((1+cos(9.42477796077 * x))/2)

#define Action(Over, Pref)	for (i=0; i<theOverlap; i++)		\
			{z = ((double)(Pref i)/theOverlap);			\
			fact = Over(z);											\
			*(myNumber++) *= fact;}

	if (AtStart)
		switch (OverlapMode) {
			case 0:
				Action(Linear, )
				break;
			case 1:
				Action(Smooth, )
				break;
			case 2:
				Action(Cut, )
				break;
			}
	else
		switch (OverlapMode) {
			case 0:
				Action(Linear, theOverlap - )
				break;
			case 1:
				Action(Smooth, theOverlap - )
				break;
			case 2:
				Action(Cut, theOverlap - )
				break;
			}
}

void CSpec::PutZeros(long deb, long fin)
{
	double *myNumber = (double*)(mDatas->GetAddress() + deb*RealSize);
	for (long i=deb; i<=fin; i++) {
		*(myNumber++) = 0;
		}
}

double CSpec::MaxValue()
{
	double max = 1;
	complex<double> *curr = (complex<double>*)(mDatas->GetAddress() + ComplexSize);
	double a;
	for (long i=1; i<dataSize; i++) if ((a = norm(*(curr++))) > max) max = a;
	return max;
}