#include "Indicators.h"

const Rect aRect = {0,0,0,0};

CSimpleIndicator::CSimpleIndicator(Rect theRect, CWindowBase* theCreator):CRectPart(theRect, theCreator)
{
	mValue = 0;
	control = NewControl(theCreator->GetWindow(), &theRect, "\p", true, 0, 0, 1000, kControlProgressBarProc, 0);								
}

CSimpleIndicator::~CSimpleIndicator()
{
	DisposeControl(control);
}

void CSimpleIndicator::DrawPart()
{
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	Draw1Control(control);
	BackColor(whiteColor);
}

void CSimpleIndicator::_Enable()
{
//	InvalPart();
	Creator->MySetPort();
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	HiliteControl(control,0);
	BackColor(whiteColor);
	Creator->RestoreWorld();
}

void CSimpleIndicator::_Disable()
{
//	InvalPart();
	Creator->MySetPort();
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	HiliteControl(control,255);
	BackColor(whiteColor);
	Creator->RestoreWorld();
}

void CSimpleIndicator::SetValue(float newVal)
{
	Creator->MySetPort();
	RGBColor bc = Creator->GetBackColor();
	RGBBackColor(&bc);
	SetControlValue(control, 1000*newVal);
	BackColor(whiteColor);
	Creator->RestoreWorld();
//	DrawPart();
}