/************* Filter ****************\

This external filter demonstrates the use of the
CreateFilterProcess method. It allows you to create
easily your own personalized filters.

\*********************************/

#include "CExternalStuff.h"
#include "CControllers.h"
#include "NewFilter.h"

class CHighFilter: public CFilter {
public:
	virtual void ChangeSpectrum(CSpec*);
	};
	
void CHighFilter::ChangeSpectrum(CSpec* aSpec)
{
	long theSize = aSpec->GetSize();
	for (long i = 0; i<theSize; i++) {
		(*aSpec)[i] *= (2 - cos(3.1415926 * (double)i/theSize))/3;
		}
}

class CLowFilter: public CFilter {
public:
	virtual void ChangeSpectrum(CSpec*);
	};
	
void CLowFilter::ChangeSpectrum(CSpec* aSpec)
{
	long theSize = aSpec->GetSize();
	for (long i = 0; i<theSize; i++) {
		(*aSpec)[i] *= (2 + cos(3.1415926 * (double)i/theSize))/3;
		}
}

pascal void main(CSoundBase* theSound, CWindowBase* SoundWindow, CAmadBase* theApplication, CResFileBase* theFile, short theItem, long* myData)
{
	switch (theItem) {
		case kEnableItem:
			*myData = (theSound->GetSel().mSelStart != theSound->GetSel().mSelEnd);
			break;
		case 1:
			CLowFilter *myLow = new CLowFilter;
			theApplication->CreateFilterProcess(theSound, myLow);
			break;
		case 2:
			CHighFilter *myHigh = new CHighFilter;
			theApplication->CreateFilterProcess(theSound, myHigh);
			break;
		}
}