#include "CExternalStuff.h"
#include "CControllers.h"

#include "NewFilter.h"

void InverseSound(CSoundBase* theSound, CAmadBase* theApplication, CResFileBase* theFile)
{
	ShowWatch;
	SoundCar theCar = theSound->GetCar();
	SoundSel theSel = theSound->GetSel();
	
	short posChans[4], k;
	short nChansRead = theCar.mNumChans;
	for (k=0; k<nChansRead; k++)
		posChans[k] = ((theSel.mSelMode >> k)%2);
	theCar.mNumChans = theSel.NChansSel();
	short nChans = theCar.mNumChans;
	short sSize = theCar.mSampleSize;
	
	long myL = theSel.mSelEnd - theSel.mSelStart;
	if (myL == 0) return;
	
	if (!theApplication->ReserveMem(2*myL*sSize*nChans)) {
		_exterror(1, theApplication, theFile);
		return;
		}
	CSoundBase* mySound = theApplication->CreateSound(0, theCar);
	mySound->SelectAll();
	mySound->CopyFrom(theSound);
	
	long maxLength = mySound->MaxAccess()/2;
	long reallength = mySound->Length();
	long length = (maxLength>reallength)?reallength:maxLength;
	
	long N = (reallength / length) + 1;
	
	CSoundAccess* rAccess = theSound->GetReadAccess(theSel.mSelStart, length);
	if (!rAccess) return;
	CSoundAccess* wAccess = mySound->GetWriteAccess(mySound->Length() - length, length);
	if (!wAccess) return;
	
	long posRead = theSel.mSelStart;
	long posWrite = mySound->Length() - length;
	long sizeAccess = length;
	
	for (long i=0; i<N; i++) {
		switch ((i+1)%N) {
			case 0:
				sizeAccess = reallength % length;
				posRead += length;
				posWrite -= sizeAccess;
				rAccess->ResizeAccess(sizeAccess);
				wAccess->ResizeAccess(sizeAccess);
				rAccess->PositionAccess(posRead);
				wAccess->PositionAccess(posWrite);
				break;
			case 1:
				break;
			default:
				posRead += length;
				posWrite -= length;
				rAccess->PositionAccess(posRead);
				wAccess->PositionAccess(posWrite);
				break;
			}
		if (!sizeAccess) break;
		CSample* rSample = rAccess->GetSamplePtr(0, 0);
		CSample* wSample = wAccess->GetSamplePtr(sizeAccess-1, 0);
		
		long rPos = (long)rSample-sSize;
		long wPos = (long)wSample;
		switch (sSize) {
			case 1:
				for (long j = 0; j<sizeAccess; j++) {
					for (k = 0; k<nChansRead; k++) {
						rSample = (CSample*)(rPos += 1);
						if (posChans[k]) {
							wSample->m8Bits = rSample->m8Bits;
							wSample = (CSample*)(wPos += 1);
							}
						}
					wSample = (CSample*)(wPos -= 2*nChans);
					}
				break;
			case 2:
				for (long j = 0; j<sizeAccess; j++) {
					for (k = 0; k<nChansRead; k++) {
						rSample = (CSample*)(rPos += 2);
						if (posChans[k]) {
							wSample->m16Bits = rSample->m16Bits;
							wSample = (CSample*)(wPos += 2);
							}
						}
					wSample = (CSample*)(wPos -= 4*nChans);
					}
				break;
			case 3:
				for (long j = 0; j<sizeAccess; j++) {
					for (k = 0; k<nChansRead; k++) {
						rSample = (CSample*)(rPos += 3);
						if (posChans[k]) {
							wSample->m24Bits = rSample->m24Bits;
							wSample = (CSample*)(wPos += 3);
							}
						}
					wSample = (CSample*)(wPos -= 6*nChans);
					}
				break;
			}
		wAccess->UpDateAccess();
		}
	delete rAccess;
	delete wAccess;
	mySound->SelectAll();
	theSound->CopyFrom(mySound);
	delete mySound;
}

pascal void main(CSoundBase* theSound, CWindowBase* SoundWindow, CAmadBase* theApplication, CResFileBase* theFile, short theItem, long* myData)
{
	switch (theItem) {
		case kEnableItem:
			*myData = (theSound->GetSel().mSelStart != theSound->GetSel().mSelEnd);
			break;
		case 0:
			InverseSound(theSound, theApplication, theFile);
			break;
		}
}