#ifndef INTERFCONSTS
#define INTERFCONSTS

// Standard Events

enum {
	kInternalEvent	= 1000,
	kDeleteWindow	= 1003,
	kCreateError	= 1004,
	kExtError			= 1005,
	kOpenFile			= 1006
	};
	
// Internal Events

enum {
	kQuitApplication	= 0,
	kSetupMenus			= 1,
	kHandlePalettes		= 2
	};

// Error types (Message for kCreateError)
	
enum {
	kAmadeusErr	= 0,
	kIOErr				= 1
	};

// Standard action types
// Action types below 1000 are reserved for internal use

enum {
	kNoAction				= 0,
	kMenuCommand		= 0xFF,
	kItemCommand		= 0x80
	};
	
// Menu ID's and menu items
	
enum {
	mApple				= 128,
	iAbout				= 1,
	iRegister			= 4,

	mFile				= 129,
	iNew					= 1,
	iOpen				= 2,
	iClose				= 3,
	iSave				= 5,
	iSaveAs			= 6,
	iSetUp				= 8,
	iPrint				= 9,
	iQuit					= 11,
	
	mEdit				= 130,
	iUndo				= 1,
	iRedo				= 2,
	iCut					= 4,
	iCopy				= 5,
	iPaste				= 6,
	iClear				= 7,
	iSelAll				= 9,
	iCopyPicture		= 11,
	iPasteSpecial	= 12,
	iScraps				= 14,
	iPalettes			= 15,
	iPrefs				= 17,
	iReload				= 18,
	
	mSelection		= 134,
	iSetSel				= 1,
	iMarkSel			= 2,
	iJump				= 4,
	iExtStart			= 6,
	iExtEnd				= 7,
	iExtNextMark	= 8,
	iExtPrevMark	= 9,
	iSaveSel			= 11,
	iSplitFile			= 12,
	iClearMarks		= 14,
	
	mSound				= 131,
	iPlay					= 1,
	iPlaySel			= 2,
	iPlayMarks		= 3,
	iRecord				= 4,
	iJumpPlay			= 6,
	iStop					= 8,
	iPause				= 9,
	iResume			= 10,
	iQuality				= 12,
	iPitch				= 13,
	
	iJumpSel			= 1,
	iJumpWhole		= 2,
	iJumpMark		= 4,
	iJumpMarks		= 5,

	mScraps			= 200,
	mSoundInput		= 201,
	mAbouts			= 223,
	mJumps			= 224
	};

// Standard color icon families

enum{
	icPlay				= 143,
	icRec				= 161,
	icPause				= 147,
	icStop				= 152,
	icChrono			= 155,
	icSound				= 158
	};

// Standard Colors

const RGBColor Black = {0x0000, 0x0000, 0x0000};
const RGBColor White = {0xFFFF, 0xFFFF, 0xFFFF};
const RGBColor FondGris = {0xAAAA, 0xAAAA, 0xAAAA};
const RGBColor FondGris2 = {0x8888, 0x8888, 0x8888};
const RGBColor GrisClair = {0xDDDD, 0xDDDD, 0xDDDD};
const RGBColor GrisFonce = {0x4444, 0x4444, 0x4444};
const RGBColor FondCouleur = {0xCCCC, 0xCCCC, 0xFFFF};
const RGBColor TraitCouleur = {0x451E, 0x451E, 0x451E};

#endif
