#ifndef ERRORS
#define ERRORS

enum {
	Memory_Err		= 1,
	Unknown_Err	= 2,
	Problem_Err		= 3,
	Wrong_Vers		= 4
	};

enum {
	StandardRes		= 5001,
	UserRes			= 6001,
	IORes				= 6003
	};
	
class Error {
protected:
	short ErrorType;
	void StandardHandler(short, short);
public:
	Error(short e = Unknown_Err) {ErrorType = e;}
	~Error() {}
	
	virtual void HandleError() {StandardHandler(ErrorType, StandardRes);}
	short ErrType() {return ErrorType;}
};

class IOError:public Error {
public:
	IOError(short e):Error(e) {}
	~IOError() {}
	void HandleError();
};

class MemoryError: public Error{
public:
	MemoryError():Error(0) {}
	~MemoryError() {}
	void HandleError() {StandardHandler(Memory_Err, StandardRes);}
};

class Problem: public Error{
public:
	Problem():Error(0) {}
	~Problem() {}
	void HandleError() {StandardHandler(Problem_Err, StandardRes);}
};

class UserError: public Error{
public:
	UserError(short ID):Error(ID) {}
	~UserError() {}
	void HandleError() {StandardHandler(ErrorType, UserRes);}
};

#endif