#ifndef CPARTS
#define CPARTS

#include "CBaseClasses.h"

#pragma mark CPart	
class CPart{
protected:
	CWindowBase *Creator;
	short isFocused;
public:
	CPart(CWindowBase *TheCreator);
	virtual ~CPart();
	
	short HasFocus() {return isFocused;}
	virtual short WantFocus() {return false;}
	virtual void GiveFocus(short) {}
	virtual void TakeFocus() {}
	
	virtual void DrawPart() {}
	virtual void DoIdle() {}
	virtual short InPart(Point) {return false;}
	
	virtual short TrackCursor() {return false;}
	virtual void EnterPart() {}
	virtual void LeavePart() {}
	
	virtual short DoClick(EventRecord*) {return false;}
	virtual short DoKey(EventRecord*) {return false;}
	
	virtual short DoCommand(short, short) {return false;}
	virtual short DoEnable(short, short) {return false;}
	
	virtual void SysActive() {}
	virtual void SysDesActive() {}
};

#pragma mark CRectPart	
class CRectPart: public CPart{
protected:
	Rect mPartRect;
	short Actif;
	
	short ActionType;
	
	virtual void _Enable() = 0;
	virtual void _Disable() = 0;
public:
	CRectPart(Rect, CWindowBase*, short = 0);
	virtual ~CRectPart();
	
	short InPart(Point);
	
	Rect GetPartRect() {return mPartRect;}
	virtual void SetPartRect(Rect);
	virtual void InvalPart();
	virtual short DoClick(EventRecord*);
	virtual short DoKey(EventRecord*);
	
	virtual short DrawBackground() {return true;}

	void Enable() {if (Actif) return; Actif = true; _Enable();}
	void Disable() {if (!Actif) return; Actif = false; _Disable();}
	void SysActive() {if (Actif) _Enable();}
	void SysDesActive() { _Disable();}
};

class CIconPart: public CRectPart{
protected:
	Handle Icone;
	short Item;
protected:
	void _Enable();
	void _Disable();
public:
	CIconPart(Handle, Rect, CWindowBase*, short=0);
	~CIconPart();
	
	void DrawPart();
	void SetIcon(Handle);
};

class cicnButton: public CRectPart{
protected:
	CIconHandle Icone1, Icone2;
	short Item;
	short down;
	short passive, relache;
	CResFileBase* icnFile;
protected:
	void _Enable();
	void _Disable();
public:
	cicnButton(short, Rect, CWindowBase*, short=0, CResFileBase* = 0);
	~cicnButton();
	
	virtual short DoClick(EventRecord*);
	void DrawPart();
	void SetIcon(short);
	Boolean Enfonce(Boolean);
	
	void SetRelease(short N) {relache = N;}
	void SetPassive(short N) {passive = N;}
	void SetDown(short N);
	
	virtual void DoAction();
};

#endif