#ifndef CPARTS2HEADER
#define CPARTS2HEADER

#include "CParts.h"
#include <string.h>

class CResFileBase;
class CWindowBase;

class CCommandButton:public cicnButton {
	long myCommand;
	short mID, mItem;
public:
	CCommandButton(short, short, short, Rect, CWindowBase*);
	~CCommandButton() {}
	
	virtual void DoAction();
	virtual void DoIdle();
	};
	
class CPict:public CRectPart {
	PicHandle myPicture;
	CResFileBase* rFile;
protected:
	virtual void _Enable();
	virtual void _Disable();
public:
	CPict(short, Rect, CWindowBase*, short = 0, CResFileBase* = 0);
	~CPict() {}
	
	void ChangePicture(short);
	
	virtual void DrawPart();
	};
	
class CTextPart:public CRectPart {
protected:
	string myText;
	short Font;
	short Size;
	short Face;
	short Justify;
	
	virtual void _UpDateText(short) = 0;
public:
	CTextPart(string, Rect, CWindowBase*, short = 0);
	~CTextPart() {}
	
	virtual void SetText(string);
	virtual string GetText() {return myText;}
	void SetFont(short);
	void SetSize(short);
	void SetFace(short);
	void SetJustify(short);
	
	void WriteData(char*,...);
	void ReadData(char*,...);
	};
	
class CStaticText: public CTextPart {
	short mActive, withFrame;
protected:
	virtual void _Enable();
	virtual void _Disable();
	virtual void _UpDateText(short);
public:
	CStaticText(string, Rect, CWindowBase*, short = 0);
	~CStaticText() {}
	void ShowFrame(short);
	
	virtual void DrawPart();
	};
	
class CEditText: public CTextPart {
protected:
	short isActif;
	TEHandle myTEHandle;
	Rect ActualRect;

	virtual void _Enable();
	virtual void _Disable();
	virtual void _UpDateText(short);
	virtual void DrawFocus();
public:
	CEditText(string, Rect, CWindowBase*, short = 0);
	~CEditText();
	
	virtual short WantFocus() {return true;}
	virtual void GiveFocus(short);
	virtual void TakeFocus();
	virtual string GetText();
	
	virtual short DoEnable(short, short);
	virtual short DoCommand(short, short);
	virtual void SetPartRect(Rect);
	
	virtual short TrackCursor() {return true;}
	virtual void EnterPart();

	virtual short DoClick(EventRecord*);
	virtual short DoKey(EventRecord*);
	virtual void DoIdle();
	virtual void DrawPart();
	virtual void InvalPart();
	};
	
class CControlPart: public CTextPart {
protected:
	ControlRef theControl;
	
	virtual void _Enable();
	virtual void _Disable();
	virtual void _UpDateText(short);
public:
	CControlPart(short, string, Rect, CWindowBase*, short = 0, short = 0, short = 0);
	~CControlPart();
	
	void SetValue(short);
	void SetMin(short);
	void SetMax(short);
	short GetValue();
	void SetHilite(short);
	
	virtual void SetPartRect(Rect);
	
	void SetData(short, unsigned long, long, void*);
	ControlRef GetControl() {return theControl;}
	virtual short DoClick(EventRecord*);
	virtual void DrawPart();
	};
	
class CUserRectPart: public CRectPart {
	virtual void _Enable() {}
	virtual void _Disable() {}
public:
	CUserRectPart(Rect r, CWindowBase* w):CRectPart(r,w){}
	~CUserRectPart() {}
	virtual void DrawPart() {}
	};
	
class CFrame: public CStaticText {
	short drawName;
	short mActif;
protected:
	virtual void _Enable();
	virtual void _Disable();
	virtual void _UpDateText(short);
public:
	CFrame(Rect, CWindowBase*);
	~CFrame() {}
	
	void PutTitle(string);
	void RemoveTitle();
	virtual short DoClick(EventRecord*);
	
	virtual void DrawPart();
	};
	
#endif