#ifndef DLGPARTS
#define DLGPARTS

#include "CParts.h"
#include "CParts2.h"
#include "CUtils.h"
#include <complex.h>

class CResFileBase;
class CWindowBase;

#pragma mark CMenuButton	
class CMenuButton: public CTextPart{
	CResFileBase* myFile;
	Point Pos;
	MenuHandle theMenu;
	short Choix, myID;
	ControlHandle MenuControl;
protected:
	virtual void _Enable();
	virtual void _Disable();
	virtual void _UpDateText(short);
public:
	CMenuButton(short, short, Rect, CWindowBase*, CResFileBase* = 0);
	~CMenuButton();
	
	virtual void DrawPart();
	virtual short DoClick(EventRecord*);
	
	void ChangedMenu(short);
	short GetChoice() {return Choix;}
	void PutChoice(short);
};

#pragma mark COffScreenPart	
class COffScreenPart: public CRectPart, public COffScreenWorld{
	short isActif;
protected:
	virtual void _Enable();
	virtual void _Disable();
public:
	COffScreenPart(Rect, CWindowBase*, short = 1, short = true);
	~COffScreenPart();
	
	virtual void DrawPart();
	};

#pragma mark CPointsPart	
class CShowPoint {
public:
	virtual void Show(double, double) = 0;
	};

class CPointsPart: public COffScreenPart {
	CList< complex<double> > *myPoints;
	short linear;
	Rect OffRect;
	CShowPoint *myShow;
	
	void _MoveTo(complex<double>*);
	void _LineTo(complex<double>*);
	
	complex<double> *AddPoint(Point);
	void MovePoint(complex<double>*, Point, short&);
public:
	CPointsPart(Rect, CWindowBase*);
	~CPointsPart();
	
	void UpDatePart();
	virtual short TrackCursor() {return true;}
	virtual void EnterPart();
	virtual void LeavePart();
	
	CList< complex<double> > *GetPoints() {return myPoints;}
	void SetPoints(CList< complex<double> > *);
	double GetFunction(double);
	
	virtual short DoClick(EventRecord*);
	virtual void InvalPart();
	
	void SetLinear(short nlin);
	void SetToZero();
	void SetShow(CShowPoint* aShow) {myShow = aShow;}
	};
	
#pragma mark 	CScalePart
class CScalePart: public CRectPart {
protected:
	double min, max;
	short horiz, logarithmic, orientation;
	double bigSpace;
	short nSmall, isActif, theLength;
	string format;
	string before, after;
	
	void DrawSmall(short);
	void DrawBig(short, double);
	
	virtual string MakeText(double);
	
	virtual void _Enable();
	virtual void _Disable();
public:
	CScalePart(Rect, CWindowBase*, short=0);
	~CScalePart() {};
	
	virtual void DrawPart();
	virtual void InvalPart();
	virtual void SetPartRect(Rect);
	
	void SetMin(double nMin) {min = nMin; InvalPart();}
	void SetMax(double nMax) {max = nMax; InvalPart();}
	void SpaceGrad(double space) {bigSpace = space; InvalPart();}
	void NSmall(short s) {nSmall = s; InvalPart();}
	
	void SetBefore(string nb) {before = nb; InvalPart();}
	void SetAfter(string na) {after = na; InvalPart();}
	void SetDigits(short);
	
	void SetLogarithmic(short lo) {logarithmic = lo; InvalPart();}
	};
	

#endif